{*******************************************************************************
 * DSPack 1.03                                                                *
 *                                                                             *
 * home page : http://www.progdigy.com                                         *
 * email     : hgourvest@progdigy.com                                          *
 *                                                                             *
 * date      : 27-05-2001                                                      *
 *******************************************************************************}

unit dspack;

interface
uses Windows, Messages, Controls, OleServer, Classes, Forms, ActiveX, ComObj, sysutils,
     comctrls, consts, DirectShow, DSUtil;

type
  TDSGraph = class;

  TOnDebug = procedure(sender: TComponent; text: string) of object ;

//******************************************************************************
//
// TDSVideoWindow declaration
//
//******************************************************************************
  TDSVideoWindow = class(TCustomControl)
  private
    FIsFullScreen : boolean;
    FVidHandle    : HWND;
    FGraph        : TDSGraph;
    FOnVidKeyDown   : TKeyEvent;
    FOnVidKeyUp     : TKeyEvent;
    FOnVidDblClick  : TMouseEvent;
    FOnVidMouseDown : TMouseEvent;
    FOnVidMouseUp   : TMouseEvent;
    FOnVidMouseMove : TMouseMoveEvent;
    procedure SetGraph(grf : TDSGraph);
    function  VideoAvailable: boolean;
    procedure VidWndProc(var Msg: TMessage);
    function  GetVideoHandle(out VideoHandle: HWND): boolean;
    procedure CaptureCanvas(Sender: TObject);
    procedure ReleaseCanvas(Sender: TObject);
  protected
    procedure Resize; override;
  public
    constructor Create(AOwner: TComponent);override;
    destructor  Destroy; override;
    function    StartFullScreen: boolean;
    function    StopFullScreen: boolean;
    property    IsFullScreen: boolean read FIsFullScreen;
  published
    property Graph: TDSGraph read FGraph write SetGraph;
    property Canvas;
    property PopupMenu;
    property Align;
    property OnVidKeyDown   : TKeyEvent       read FOnVidKeyDown   write FOnVidKeyDown;
    property OnVidKeyUp     : TKeyEvent       read FOnVidKeyUp     write FOnVidKeyUp;
    property OnVidDblClick  : TMouseEvent     read FOnVidDblClick  write FOnVidDblClick;
    property OnVidMouseDown : TMouseEvent     read FOnVidMouseDown write FOnVidMouseDown;
    property OnVidMouseUp   : TMouseEvent     read FOnVidMouseUp   write FOnVidMouseUp;
    property OnVidMouseMove : TMouseMoveEvent read FOnVidMouseMove write FOnVidMouseMove;
  end;

//******************************************************************************
//
// TDSTrackBar declaration
//
//******************************************************************************
  TDSFilterGraph2 = class;

  TDSTrackBar = class(TTrackBar)
  private
    FTimerEnable  : boolean;
    FInterval     : Cardinal;
    FWindowHandle : HWND;
    FGraph        : TDSFilterGraph2;
    procedure UpdateTimer;
    procedure WndProc2(var Msg: TMessage);
    procedure SetTimerEnabled(Value: Boolean);
    procedure SetGraph(grf: TDSFilterGraph2);
    function  SeekingAvailable: boolean;
    function  GetCapabilities: TDSAMSeekingKind;
    function  GetRate: double;
    procedure SetRate(rate: Double);
    procedure ReceiveEndOfStream;
  protected
    procedure Timer; dynamic;
    procedure Changed; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    property Capabilities : TDSAMSeekingKind read GetCapabilities;
    property Graph : TDSFilterGraph2 read FGraph write SetGraph;
    property Rate: double read GetRate write SetRate;
  end;

//******************************************************************************
// TDSGraph declaration
// Don't use directly !!
// Used internaly to receive Events from a Filter Graph, connections ...
//******************************************************************************
  TVideoSize = record
    Width : WORD;
    Height: WORD;
  end;

  TOnDSEvent = procedure(sender: TOleServer; Event, Param1, Param2: longint) of object;

  TOnGraphBufferingData           = procedure(sender: TComponent; Buffering: boolean) of object ;
  TOnGraphClockChanged            = procedure(sender: TComponent) of object ;
  TOnGraphComplete                = procedure(sender: TComponent; Result: HRESULT; Renderer: IBaseFilter) of object ;
  TOnGraphDeviceLost              = procedure(sender: TComponent; Device: IUnknown; Removed: Boolean) of object ;
  TOnGraphEndOfSegment            = procedure(sender: TComponent; StreamTime: TREFERENCE_TIME; NumSegment: Cardinal) of object ;
  TOnGraphErrorStillPlaying       = procedure(sender: TComponent; Result: HRESULT) of object ;
  TOnGraphErrorAbort              = procedure(sender: TComponent; Result: HRESULT) of object ;
  TOnGraphFullscreenLost          = procedure(sender: TComponent; Renderer: IBaseFilter) of object ;
  TOnGraphChanged                 = procedure(sender: TComponent) of object ;
  TOnGraphOleEvent                = procedure(sender: TComponent; String1, String2: string) of object ;
  TOnGraphOpeningFile             = procedure(sender: TComponent; opening: boolean) of object ;
  TOnGraphPaletteChanged          = procedure(sender: TComponent) of object ;
  TOnGraphPaused                  = procedure(sender: TComponent; Result: HRESULT) of object ;
  TOnGraphQualityChange           = procedure(sender: TComponent) of object ;
  TOnGraphSNDDevInError           = procedure(sender: TComponent; OccurWhen: TSNDDEV_ERR; ErrorCode: DWORD) of object ;
  TOnGraphSNDDevOutError          = procedure(sender: TComponent; OccurWhen: TSNDDEV_ERR; ErrorCode: DWORD) of object ;
  TOnGraphStepComplete            = procedure(sender: TComponent) of object ;
  TOnGraphStreamControlStarted    = procedure(sender: TComponent; PinSender: IPin; Cookie: DWORD) of object ;
  TOnGraphStreamControlStopped    = procedure(sender: TComponent; PinSender: IPin; Cookie: DWORD) of object ;
  TOnGraphStreamErrorStillPlaying = procedure(sender: TComponent; Operation: HRESULT; Value: DWORD) of object ;
  TOnGraphStreamErrorStopped      = procedure(sender: TComponent; Operation: HRESULT; Value: DWORD) of object ;
  TOnGraphUserAbort               = procedure(sender: TComponent) of object ;
  TOnGraphVideoSizeChanged        = procedure(sender: TComponent; size: TVideoSize) of object ;
  TOnGraphTimeCodeAvailable       = procedure(sender: TComponent; From: IBaseFilter; DeviceID: DWORD) of object ;
  TOnGraphEXTDeviceModeChange     = procedure(sender: TComponent; NewMode, DeviceID: DWORD) of object ;

  TDSGraph = class(TOleServer)
  private
    FHandle : HWND;
    FVW : TDSVideoWindow;
    // ROT
    dwregister : longint;
    FRotEnabled: boolean;
    // All Events Code
    FOnDSEvent : TOnDSEvent; 
    // Graph Events
    FOnGraphBufferingData           : TOnGraphBufferingData;
    FOnGraphClockChanged            : TOnGraphClockChanged;
    FOnGraphComplete                : TOnGraphComplete;
    FOnGraphDeviceLost              : TOnGraphDeviceLost;
    FOnGraphEndOfSegment            : TOnGraphEndOfSegment;
    FOnGraphErrorStillPlaying       : TOnGraphErrorStillPlaying;
    FOnGraphErrorAbort              : TOnGraphErrorAbort;
    FOnGraphFullscreenLost          : TOnGraphFullscreenLost;
    FOnGraphChanged                 : TOnGraphChanged;
    FOnGraphOleEvent                : TOnGraphOleEvent;
    FOnGraphOpeningFile             : TOnGraphOpeningFile;
    FOnGraphPaletteChanged          : TOnGraphPaletteChanged;
    FOnGraphPaused                  : TOnGraphPaused;
    FOnGraphQualityChange           : TOnGraphQualityChange;
    FOnGraphSNDDevInError           : TOnGraphSNDDevInError;
    FOnGraphSNDDevOutError          : TOnGraphSNDDevOutError;
    FOnGraphStepComplete            : TOnGraphStepComplete;
    FOnGraphStreamControlStarted    : TOnGraphStreamControlStarted;
    FOnGraphStreamControlStopped    : TOnGraphStreamControlStopped;
    FOnGraphStreamErrorStillPlaying : TOnGraphStreamErrorStillPlaying;
    FOnGraphStreamErrorStopped      : TOnGraphStreamErrorStopped;
    FOnGraphUserAbort               : TOnGraphUserAbort;
    FOnGraphVideoSizeChanged        : TOnGraphVideoSizeChanged;
    FOnGraphTimeCodeAvailable       : TOnGraphTimeCodeAvailable;
    FOnGraphEXTDeviceModeChange     : TOnGraphEXTDeviceModeChange;
    procedure WndProc(var Msg: TMessage);
    procedure FDoEvent;
  protected
    procedure DoEvent(Event, Param1, Param2: longint); dynamic;
    procedure SetROT(value: boolean);
  public
    VideoWindow     : IVideoWindow;
    MediaSeeking    : IMediaSeeking;
    MediaEventEx    : IMediaEventEx;
    GraphBuilder    : IGraphBuilder;
    MediaControl    : IMediaControl;
    BasicAudio      : IBasicAudio;
    BasicVideo2     : IBasicVideo2;
    AMGraphStreams  : IAMGraphStreams;
    FilterChain     : IFilterChain;
    FilterMapper2   : IFilterMapper2;
    GraphConfig     : IGraphConfig;
    GraphVersion    : IGraphVersion;
    MediaEventSink  : IMediaEventSink;
    QueueCommand    : IQueueCommand;
    ResourceManager : IResourceManager;
    VideoFrameStep  : IVideoFrameStep;
    function Connected: boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure QueryInterfaces; dynamic;
    procedure ClearGraph; dynamic;
  published
    property RotEnabled: boolean read FRotEnabled write SetRot default false;
    property OnDSEvent: TOnDSEvent read FOnDSEvent write FOnDSEvent;
    property OnGraphBufferingData           : TOnGraphBufferingData           read FOnGraphBufferingData           write FOnGraphBufferingData;
    property OnGraphClockChanged            : TOnGraphClockChanged            read FOnGraphClockChanged            write FOnGraphClockChanged;
    property OnGraphComplete                : TOnGraphComplete                read FOnGraphComplete                write FOnGraphComplete;
    property OnGraphDeviceLost              : TOnGraphDeviceLost              read FOnGraphDeviceLost              write FOnGraphDeviceLost;
    property OnGraphEndOfSegment            : TOnGraphEndOfSegment            read FOnGraphEndOfSegment            write FOnGraphEndOfSegment;
    property OnGraphErrorStillPlaying       : TOnGraphErrorStillPlaying       read FOnGraphErrorStillPlaying       write FOnGraphErrorStillPlaying;
    property OnGraphErrorAbort              : TOnGraphErrorAbort              read FOnGraphErrorAbort              write FOnGraphErrorAbort;
    property OnGraphFullscreenLost          : TOnGraphFullscreenLost          read FOnGraphFullscreenLost          write FOnGraphFullscreenLost;
    property OnGraphChanged                 : TOnGraphChanged                 read FOnGraphChanged                 write FOnGraphChanged;
    property OnGraphOleEvent                : TOnGraphOleEvent                read FOnGraphOleEvent                write FOnGraphOleEvent;
    property OnGraphOpeningFile             : TOnGraphOpeningFile             read FOnGraphOpeningFile             write FOnGraphOpeningFile;
    property OnGraphPaletteChanged          : TOnGraphPaletteChanged          read FOnGraphPaletteChanged          write FOnGraphPaletteChanged;
    property OnGraphPaused                  : TOnGraphPaused                  read FOnGraphPaused                  write FOnGraphPaused;
    property OnGraphQualityChange           : TOnGraphQualityChange           read FOnGraphQualityChange           write FOnGraphQualityChange;
    property OnGraphSNDDevInError           : TOnGraphSNDDevInError           read FOnGraphSNDDevInError           write FOnGraphSNDDevInError;
    property OnGraphSNDDevOutError          : TOnGraphSNDDevOutError          read FOnGraphSNDDevOutError          write FOnGraphSNDDevOutError;
    property OnGraphStepComplete            : TOnGraphStepComplete            read FOnGraphStepComplete            write FOnGraphStepComplete;
    property OnGraphStreamControlStarted    : TOnGraphStreamControlStarted    read FOnGraphStreamControlStarted    write FOnGraphStreamControlStarted;
    property OnGraphStreamControlStopped    : TOnGraphStreamControlStopped    read FOnGraphStreamControlStopped    write FOnGraphStreamControlStopped;
    property OnGraphStreamErrorStillPlaying : TOnGraphStreamErrorStillPlaying read FOnGraphStreamErrorStillPlaying write FOnGraphStreamErrorStillPlaying;
    property OnGraphStreamErrorStopped      : TOnGraphStreamErrorStopped      read FOnGraphStreamErrorStopped      write FOnGraphStreamErrorStopped;
    property OnGraphUserAbort               : TOnGraphUserAbort               read FOnGraphUserAbort               write FOnGraphUserAbort;
    property OnGraphVideoSizeChanged        : TOnGraphVideoSizeChanged        read FOnGraphVideoSizeChanged        write FOnGraphVideoSizeChanged;
    property OnGraphTimeCodeAvailable       : TOnGraphTimeCodeAvailable       read FOnGraphTimeCodeAvailable       write FOnGraphTimeCodeAvailable;
    property OnGraphEXTDeviceModeChange     : TOnGraphEXTDeviceModeChange     read FOnGraphEXTDeviceModeChange     write FOnGraphEXTDeviceModeChange;
  end;

//******************************************************************************
//
// TDSFilterGraph2 declaration
// use IFilterGraph2 only
//******************************************************************************
  TDSFilterGraph2 = class(TDSGraph)
  private
    FTB : TDSTrackBar;
  protected
    procedure InitServerData; override;
    procedure DoEvent(Event, Param1, Param2: longint); override;
  public
    FilterGraph2    : IFilterGraph2;
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure Disconnect; override;
    procedure QueryInterfaces; override;
    procedure ClearGraph; override;
  published
  end;

//******************************************************************************
//
// TDSDVDGraph declaration
//
//******************************************************************************
  TOnDVDAudioStreamChange      = procedure(sender: TComponent;stream, lcid: longint; Lang: string) of object;
  TOnDVDCurrentTime            = procedure(sender: TComponent;heures,minutes,secondes,frames,frate : longint) of object;
  TOnDVDTitleChange            = procedure(sender: TComponent;title: longint) of object;
  TOnDVDChapterStart           = procedure(sender: TComponent;chapter: longint) of object;
  TOnDVDDomain                 = procedure(sender: TComponent) of object;
  TOnDVDAngleChange            = procedure(sender: TComponent;total,current : longint) of object;
  TOnDVDValidUOPSChange        = procedure(sender: TComponent;UOPS: TUOPS) of object;
  TOnDVDButtonChange           = procedure(sender: TComponent;total,current: longint) of object;
  TOnDVDChapterAutoStop        = procedure(sender: TComponent) of object;
  TOnDVDStillOn                = procedure(sender: TComponent; NoButtonAvailable: boolean; seconds: longint) of object;
  TOnDVDStillOff               = procedure(sender: TComponent) of object ;
  TOnDVDSubpictureStreamChange = procedure(sender: TComponent; SubNum, lcid: longint; Lang: string) of object;
  TOnDVDError                  = procedure(sender: TComponent) of object;
  TOnDVDNoFP_PGC               = procedure(sender: TComponent) of object;
  TOnDVDWarning                = procedure(sender: TComponent) of object;
  TOnDVDPlaybackRateChange     = procedure(sender: TComponent; rate:  longint) of object;
  TOnDVDParentalLevelChange    = procedure(sender: TComponent; level: longint) of object;
  TOnDVDPlaybackStopped        = procedure(sender: TComponent) of object;
  TOnDVDAnglesAvailable        = procedure(sender: TComponent; available: boolean) of object;
  TOnDVDPlayPeriodAutoStop     = procedure(sender: TComponent) of object;
  TOnDVDButtonAutoActivated    = procedure(sender: TComponent; Button: DWORD) of object;
  TOnDVDCMDStart               = procedure(sender: TComponent; CmdID: DWORD) of object;
  TOnDVDCMDEnd                 = procedure(sender: TComponent; CmdID: DWORD) of object;
  TOnDVDDiscEjected            = procedure(sender: TComponent) of object;
  TOnDVDDiscInserted           = procedure(sender: TComponent) of object;
  TOnDVDCurrentHMSFTime        = procedure(sender: TComponent; HMSFTimeCode: TDVD_HMSF_TIMECODE; TimeCode: TDVD_TimeCode) of object;
  TOnDVDKaraokeMode            = procedure(sender: TComponent; Played: BOOL) of object;

  TDSDVDGraph = class(TDSGraph)
  private
      FOnDVDAudioStreamChange       : TOnDVDAudioStreamChange     ;
      FOnDVDCurrentTime             : TOnDVDCurrentTime           ;
      FOnDVDTitleChange             : TOnDVDTitleChange           ;
      FOnDVDChapterStart            : TOnDVDChapterStart          ;
      FOnDVDAngleChange             : TOnDVDAngleChange           ;
      FOnDVDValidUOPSChange         : TOnDVDValidUOPSChange       ;
      FOnDVDButtonChange            : TOnDVDButtonChange          ;
      FOnDVDChapterAutoStop         : TOnDVDChapterAutoStop       ;
      FOnDVDStillOn                 : TOnDVDStillOn               ;
      FOnDVDStillOff                : TOnDVDStillOff              ;
      FOnDVDSubpictureStreamChange  : TOnDVDSubpictureStreamChange;
      FOnDVDNoFP_PGC                : TOnDVDNoFP_PGC              ;
      FOnDVDPlaybackRateChange      : TOnDVDPlaybackRateChange    ;
      FOnDVDParentalLevelChange     : TOnDVDParentalLevelChange   ;
      FOnDVDPlaybackStopped         : TOnDVDPlaybackStopped       ;
      FOnDVDAnglesAvailable         : TOnDVDAnglesAvailable       ;
      FOnDVDPlayPeriodAutoStop      : TOnDVDPlayPeriodAutoStop    ;
      FOnDVDButtonAutoActivated     : TOnDVDButtonAutoActivated   ;
      FOnDVDCMDStart                : TOnDVDCMDStart              ;
      FOnDVDCMDEnd                  : TOnDVDCMDEnd                ;
      FOnDVDDiscEjected             : TOnDVDDiscEjected           ;
      FOnDVDDiscInserted            : TOnDVDDiscInserted          ;
      FOnDVDCurrentHMSFTime         : TOnDVDCurrentHMSFTime       ;
      FOnDVDKaraokeMode             : TOnDVDKaraokeMode           ;
      // DVD Warning
      FOnDVDWarningInvalidDVD1_0Disc  : TOnDVDWarning;//=1,
      FOnDVDWarningFormatNotSupported : TOnDVDWarning;//=2,
      FOnDVDWarningIllegalNavCommand  : TOnDVDWarning;//=3
      FOnDVDWarningOpen               : TOnDVDWarning;//=4
      FOnDVDWarningSeek               : TOnDVDWarning;//=5
      FOnDVDWarningRead               : TOnDVDWarning;//=6
      // DVDDomain
      FOnDVDDomainFirstPlay         : TOnDVDDomain;
      FOnDVDDomainVideoManagerMenu  : TOnDVDDomain;
      FOnDVDDomainVideoTitleSetMenu : TOnDVDDomain;
      FOnDVDDomainTitle             : TOnDVDDomain;
      FOnDVDDomainStop              : TOnDVDDomain;
      // DVDError
      FOnDVDErrorUnexpected                          : TOnDVDError;
      FOnDVDErrorCopyProtectFail                     : TOnDVDError;
      FOnDVDErrorInvalidDVD1_0Disc                   : TOnDVDError;
      FOnDVDErrorInvalidDiscRegion                   : TOnDVDError;
      FOnDVDErrorLowParentalLevel                    : TOnDVDError;
      FOnDVDErrorMacrovisionFail                     : TOnDVDError;
      FOnDVDErrorIncompatibleSystemAndDecoderRegions : TOnDVDError;
      FOnDVDErrorIncompatibleDiscAndDecoderRegions   : TOnDVDError;
  protected
    procedure InitServerData; override;
    procedure DoEvent(Event, Param1, Param2: longint); override;
  public
    DvdGraphBuilder : IDvdGraphBuilder;
    DvdControl2     : IDvdControl2;
    DvdInfo2        : IDvdInfo2;
    AMLine21Decoder : IAMLine21Decoder;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Connect; override;
    procedure Disconnect; override;
    procedure QueryInterfaces; override;
    procedure SaveBookmark(BookMarkFile: string);
    procedure RestoreBookmark(BookMarkFile: string);
  published
      property OnDVDAudioStreamChange     : TOnDVDAudioStreamChange      read FOnDVDAudioStreamChange      write FOnDVDAudioStreamChange     ;
      property OnDVDCurrentTime           : TOnDVDCurrentTime            read FOnDVDCurrentTime            write FOnDVDCurrentTime           ;
      property OnDVDTitleChange           : TOnDVDTitleChange            read FOnDVDTitleChange            write FOnDVDTitleChange           ;
      property OnDVDChapterStart          : TOnDVDChapterStart           read FOnDVDChapterStart           write FOnDVDChapterStart          ;
      property OnDVDAngleChange           : TOnDVDAngleChange            read FOnDVDAngleChange            write FOnDVDAngleChange           ;
      property OnDVDValidUOPSChange       : TOnDVDValidUOPSChange        read FOnDVDValidUOPSChange        write FOnDVDValidUOPSChange       ;
      property OnDVDButtonChange          : TOnDVDButtonChange           read FOnDVDButtonChange           write FOnDVDButtonChange          ;
      property OnDVDChapterAutoStop       : TOnDVDChapterAutoStop        read FOnDVDChapterAutoStop        write FOnDVDChapterAutoStop       ;
      property OnDVDStillOn               : TOnDVDStillOn                read FOnDVDStillOn                write FOnDVDStillOn               ;
      property OnDVDStillOff              : TOnDVDStillOff               read FOnDVDStillOff               write FOnDVDStillOff              ;
      property OnDVDSubpictureStreamChange: TOnDVDSubpictureStreamChange read FOnDVDSubpictureStreamChange write FOnDVDSubpictureStreamChange;
      property OnDVDNoFP_PGC              : TOnDVDNoFP_PGC               read FOnDVDNoFP_PGC               write FOnDVDNoFP_PGC              ;
      property OnDVDPlaybackRateChange    : TOnDVDPlaybackRateChange     read FOnDVDPlaybackRateChange     write FOnDVDPlaybackRateChange    ;
      property OnDVDParentalLevelChange   : TOnDVDParentalLevelChange    read FOnDVDParentalLevelChange    write FOnDVDParentalLevelChange   ;
      property OnDVDPlaybackStopped       : TOnDVDPlaybackStopped        read FOnDVDPlaybackStopped        write FOnDVDPlaybackStopped       ;
      property OnDVDAnglesAvailable       : TOnDVDAnglesAvailable        read FOnDVDAnglesAvailable        write FOnDVDAnglesAvailable       ;
      property OnDVDPlayPeriodAutoStop    : TOnDVDPlayPeriodAutoStop     read FOnDVDPlayPeriodAutoStop     write FOnDVDPlayPeriodAutoStop    ;
      property OnDVDButtonAutoActivated   : TOnDVDButtonAutoActivated    read FOnDVDButtonAutoActivated    write FOnDVDButtonAutoActivated   ;
      property OnDVDCMDStart              : TOnDVDCMDStart               read FOnDVDCMDStart               Write FOnDVDCMDStart              ;
      property OnDVDCMDEnd                : TOnDVDCMDEnd                 read FOnDVDCMDEnd                 Write FOnDVDCMDEnd                ;
      property OnDVDDiscEjected           : TOnDVDDiscEjected            read FOnDVDDiscEjected            Write FOnDVDDiscEjected           ;
      property OnDVDDiscInserted          : TOnDVDDiscInserted           read FOnDVDDiscInserted           write FOnDVDDiscInserted          ;
      property OnDVDCurrentHMSFTime       : TOnDVDCurrentHMSFTime        read FOnDVDCurrentHMSFTime        write FOnDVDCurrentHMSFTime       ;
      property OnDVDKaraokeMode           : TOnDVDKaraokeMode            read FOnDVDKaraokeMode            write FOnDVDKaraokeMode           ;
      //DVD Domain
      property OnDVDDomainFirstPlay         : TOnDVDDomain read FOnDVDDomainFirstPlay         write FOnDVDDomainFirstPlay         ;
      property OnDVDDomainVideoManagerMenu  : TOnDVDDomain read FOnDVDDomainVideoManagerMenu  write FOnDVDDomainVideoManagerMenu  ;
      property OnDVDDomainVideoTitleSetMenu : TOnDVDDomain read FOnDVDDomainVideoTitleSetMenu write FOnDVDDomainVideoTitleSetMenu ;
      property OnDVDDomainTitle             : TOnDVDDomain read FOnDVDDomainTitle             write FOnDVDDomainTitle             ;
      property OnDVDDomainStop              : TOnDVDDomain read FOnDVDDomainStop              write FOnDVDDomainStop              ;
      //DVD Error
      property OnDVDErrorUnexpected                          : TOnDVDError read FOnDVDErrorUnexpected                          write FOnDVDErrorUnexpected;
      property OnDVDErrorCopyProtectFail                     : TOnDVDError read FOnDVDErrorCopyProtectFail                     write FOnDVDErrorCopyProtectFail;
      property OnDVDErrorInvalidDVD1_0Disc                   : TOnDVDError read FOnDVDErrorInvalidDVD1_0Disc                   write FOnDVDErrorInvalidDVD1_0Disc;
      property OnDVDErrorInvalidDiscRegion                   : TOnDVDError read FOnDVDErrorInvalidDiscRegion                   write FOnDVDErrorInvalidDiscRegion;
      property OnDVDErrorLowParentalLevel                    : TOnDVDError read FOnDVDErrorLowParentalLevel                    write FOnDVDErrorLowParentalLevel;
      property OnDVDErrorMacrovisionFail                     : TOnDVDError read FOnDVDErrorMacrovisionFail                     write FOnDVDErrorMacrovisionFail;
      property OnDVDErrorIncompatibleSystemAndDecoderRegions : TOnDVDError read FOnDVDErrorIncompatibleSystemAndDecoderRegions write FOnDVDErrorIncompatibleSystemAndDecoderRegions;
      property OnDVDErrorIncompatibleDiscAndDecoderRegions   : TOnDVDError read FOnDVDErrorIncompatibleDiscAndDecoderRegions   write FOnDVDErrorIncompatibleDiscAndDecoderRegions;
      //DVD Warning
      property OnDVDWarningInvalidDVD1_0Disc  : TOnDVDWarning read FOnDVDWarningInvalidDVD1_0Disc  write FOnDVDWarningInvalidDVD1_0Disc  ; //=1,
      property OnDVDWarningFormatNotSupported : TOnDVDWarning read FOnDVDWarningFormatNotSupported write FOnDVDWarningFormatNotSupported ; //=2,
      property OnDVDWarningIllegalNavCommand  : TOnDVDWarning read FOnDVDWarningIllegalNavCommand  write FOnDVDWarningIllegalNavCommand  ; //=3
      property OnDVDWarningOpen               : TOnDVDWarning read FOnDVDWarningOpen               write FOnDVDWarningOpen               ; //=4
      property OnDVDWarningSeek               : TOnDVDWarning read FOnDVDWarningSeek               write FOnDVDWarningSeek               ; //=5
      property OnDVDWarningRead               : TOnDVDWarning read FOnDVDWarningRead               write FOnDVDWarningRead               ; //=6
  end;

//******************************************************************************
//
// TDSCaptureGraph declaration
//
//******************************************************************************
  TDSCaptureGraph = class(TDSFilterGraph2)
  private
  protected
    procedure InitServerData; override;
  public
    CaptureGraphBuilder2 : ICaptureGraphBuilder2;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Connect; override;
    procedure Disconnect; override;
    procedure QueryInterfaces; override;
  published
  end;

//******************************************************************************
//
// TDSSysDevEnum declaration
//
//******************************************************************************
  PDSFilCatNode = ^TDSFilCatNode;
  TDSFilCatNode = record
    FriendlyName : Shortstring;
    CLSID        : TGUID;
  end;

  TDSSysDevEnum = class
    private
      FGUID       : TGUID;
      FCategories : TList;
      FFilters    : TList;
      ACategory   : PDSFilCatNode;
      procedure   GetCat(catlist: TList; CatGUID: TGUID);
      function    GetCountCategories: integer;
      function    GetCountFilters: integer;
      function    GetCategory(item: integer): TDSFilCatNode;
      function    GetFilter(item: integer): TDSFilCatNode;
    public
      procedure SelectGUIDCategory(GUID: TGUID);
      procedure SelectIndexCategory(index: integer);
      property CountCategories: integer read GetCountCategories;
      property CountFilters: integer read GetCountFilters;
      property Categories[item: integer]: TDSFilCatNode read GetCategory;
      property Filters[item: integer]: TDSFilCatNode read GetFilter;
      function GetBaseFilterByIndex(index: integer): IBaseFilter;
      Constructor Create;
      destructor Destroy; override;
    end;
//******************************************************************************

procedure Register;

//##############################################################################

implementation
//******************************************************************************
//
// TDSVideoWindow implementation
//
//******************************************************************************
  constructor TDSVideoWindow.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    self.Height := 120;
    self.Width  := 160;
    self.color  := $00000000;
    FVidHandle := AllocateHWnd(VidWndProc);
    canvas.OnChanging := CaptureCanvas;
    canvas.OnChange   := ReleaseCanvas;
  end;

  destructor TDSVideoWindow.Destroy;
  begin
    DeallocateHWnd(FVidHandle);
    inherited destroy;
  end;

  procedure TDSVideoWindow.VidWndProc(var Msg: TMessage);
  var
    ShiftState: TShiftState;
    hnd : HWND;
  begin
  with Msg do
        try
          case Msg of
            WM_KEYDOWN         :
              if assigned(FOnVidKeyDown) then
              begin
                ShiftState := KeyDataToShiftState(LPARAM);
                FOnVidKeyDown(self, WPARAMLO, ShiftState);
                if WPARAM = 0 then Exit;
              end;
            WM_KEYUP           :
              if assigned(FOnVidKeyUp) then
              begin
                ShiftState := KeyDataToShiftState(LPARAM);
                FOnVidKeyUp(self, WPARAMLO, ShiftState);
                if WPARAM = 0 then Exit;
              end;
            WM_LBUTTONDBLCLK   :
              if assigned(FOnVidDblClick) then
              begin
                FOnVidDblClick(self,mbLeft,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
            WM_MBUTTONDBLCLK   :
              if assigned(FOnVidDblClick) then
              begin
                FOnVidDblClick(self,mbMiddle,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
            WM_RBUTTONDBLCLK   : if assigned(FOnVidDblClick) then FOnVidDblClick(self,mbRight,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
            WM_LBUTTONDOWN     :
              if assigned(FOnVidMouseDown) then
              begin
                FOnVidMouseDown(self,mbLeft,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
            WM_MBUTTONDOWN     :
              if assigned(FOnVidMouseDown) then
              begin
                FOnVidMouseDown(self,mbMiddle,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
            WM_RBUTTONDOWN     :
              if assigned(FOnVidMouseDown) then
              begin
                FOnVidMouseDown(self,mbRight,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
            WM_LBUTTONUP       :
              if assigned(FOnVidMouseUp) then
              begin
                FOnVidMouseUp(self,mbLeft,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
                if GetVideoHandle(hnd) then windows.SetFocus(hnd);
              end;
            WM_MBUTTONUP       :
              if assigned(FOnVidMouseUp) then
              begin
                FOnVidMouseUp(self,mbMiddle,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
                if GetVideoHandle(hnd) then windows.SetFocus(hnd);
              end;
            WM_RBUTTONUP       :
              begin
                if assigned(PopupMenu) then PopupMenu.Popup(mouse.CursorPos.x,mouse.CursorPos.y);
                if assigned(FOnVidMouseUp) then FOnVidMouseUp(self,mbRight,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
                if GetVideoHandle(hnd) then windows.SetFocus(hnd);
              end;
            WM_MOUSEMOVE       :
              if assigned(FOnVidMouseMove) then
              begin
                FOnVidMouseMove(self,KeyDataToShiftState(WPARAM),LPARAMLO,LPARAMHI);
              end;
          else
            begin
              Result := DefWindowProc(FVidHandle, Msg, wParam, lParam);
            end;
          end;
        except
          Application.HandleException(Self);
        end;
  end;

  procedure TDSVideoWindow.SetGraph(grf: TDSGraph);
  begin
    if assigned(FGraph) then FGraph.FVW := nil;
    FGraph := grf;
    if assigned(FGraph) then
    begin
      FGraph.FVW := self;
      if VideoAvailable then
      begin
        with FGraph.VideoWindow do
        begin
          put_Owner(self.Parent.Handle);
          put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
          SetWindowPosition(self.Left,self.Top,self.Width,self.Height);
          put_MessageDrain(self.FVidHandle);
        end;
      end;
    end;
  end;

  procedure TDSVideoWindow.Resize;
  begin
    inherited Resize;
    if VideoAvailable then
    begin
      FGraph.VideoWindow.SetWindowPosition(self.Left,self.Top,self.Width,self.Height);
    end;
  end;

  function TDSVideoWindow.GetVideoHandle(out VideoHandle: HWND): boolean;
  var renderer : IBaseFilter;
      input    : IPin;
      enum     : IEnumPins;
      Overlay  : IOverlay;
  begin
    result := false;
    if assigned(FGraph) then
    begin
      if (FGraph.GraphBuilder.FindFilterByName('Video Renderer', renderer) = S_OK) then
      begin
        renderer.EnumPins(enum);
        enum.Next(1,input,nil);
        if (input.QueryInterface(IID_IOverlay, overlay) = S_OK) then
        begin
          overlay.GetWindowHandle(VideoHandle);
          result := true;
        end;
      end;
    end;
    renderer := nil;
    input    := nil;
    enum     := nil;
    Overlay  := nil;
  end;

  procedure  TDSVideoWindow.CaptureCanvas(Sender: TObject);
  var renderer : IBaseFilter;
      input    : IPin;
      enum     : IEnumPins;
      Overlay  : IOverlay;
      wh       : HWND;
      NewDC    : HDC;
      colorkey : TColorKey;
      MyColor  : TOverlayColor;
  begin
    if assigned(FGraph) then
    begin
      if (FGraph.GraphBuilder.FindFilterByName('Video Renderer', renderer) = S_OK) then
      begin
        renderer.EnumPins(enum);
        enum.Next(1,input,nil);
        if (input.QueryInterface(IID_IOverlay, overlay) = S_OK) then
        begin
          overlay.GetWindowHandle(wh);
          NewDC := getdc(wh);
          self.Canvas.Handle := NewDC;
          overlay.GetDefaultColorKey(colorkey);
          MyColor.low := colorkey.LowColorValue;
          MyColor.hight := colorkey.HighColorValue;
          self.Canvas.Brush.Color := MyColor.color;
          releasedc(wh,NewDC);
          //result := true;
        end;
      end;
    end;
    renderer := nil;
    input    := nil;
    enum     := nil;
    Overlay  := nil;
  end;

  procedure TDSVideoWindow.ReleaseCanvas(Sender: TObject);
  begin
    self.Canvas.Handle := 0;
  end;

  function TDSVideoWindow.VideoAvailable: boolean;
  begin
    result := false;
    if assigned(FGraph) then
      if assigned(FGraph.VideoWindow) then result := true;
  end;

  function TDSVideoWindow.StartFullScreen: boolean;
  var OrigStyle, OrigStyleEx: Longint;
  begin
    result := false;
    if VideoAvailable then
    begin
      with FGraph.VideoWindow do
      begin
        get_WindowStyle(OrigStyle);
        get_WindowStyleEx(OrigStyleEx);
        put_Owner(0);
        put_WindowStyle(OrigStyle and not(WS_BORDER or WS_CAPTION or WS_THICKFRAME));
        put_WindowStyleEx(OrigStyleEx and not(WS_EX_CLIENTEDGE or WS_EX_STATICEDGE
          or WS_EX_WINDOWEDGE or WS_EX_DLGMODALFRAME) or WS_EX_TOPMOST);
        SetWindowPosition(0,0,screen.Width,screen.Height);
        FIsFullScreen := true;
        result := true;
      end;
    end;
  end;

  function TDSVideoWindow.StopFullScreen: boolean;
  begin
    result := false;
    if VideoAvailable then
    begin
      with FGraph.VideoWindow do
      begin
        put_Owner(self.Parent.Handle);
        put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
        SetWindowPosition(self.Left,self.Top,self.Width,self.Height);
        result := true;
        FIsFullScreen := false;
        self.parent.SetFocus;
      end;
    end;
  end;

//******************************************************************************
//
// TDSGraph implementation
//
//******************************************************************************

  procedure TDSGraph.WndProc(var Msg: TMessage);
  begin
  with Msg do
      if Msg = WM_GRAPHNOTIFY then
        try
          FDoEvent;
        except
          Application.HandleException(Self);
        end
      else
        Result := DefWindowProc(FHandle, Msg, wParam, lParam);
  end;

  constructor TDSGraph.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    FHandle := AllocateHWnd(WndProc);
  end;

  destructor TDSGraph.Destroy;
  begin
    DeallocateHWnd(FHandle);
    inherited Destroy;
  end;

  procedure TDSGraph.FDoEvent;
  var hr: HRESULT;
      Event, Param1, Param2: LongInt;
  begin
    if assigned(MediaEventEx) then
    begin
      hr := MediaEventEx.GetEvent(Event, Param1, Param2, 0);
      while (hr = S_OK) do
      begin
        MediaEventEx.FreeEventParams(Event, Param1, Param2);
        DoEvent(Event, Param1, Param2);
        hr := MediaEventEx.GetEvent(Event, Param1, Param2, 0);
      end;
    end;
  end;

  procedure TDSGraph.DoEvent(Event, Param1, Param2: longint);
  begin
    if assigned(FOnDSEvent) then FOnDSEvent(self, Event, Param1, Param2);
    case Event of
      EC_BUFFERING_DATA            : if assigned(FOnGraphBufferingData) then FOnGraphBufferingData(self,(Param1 = 1));
      EC_CLOCK_CHANGED             : if assigned(FOnGraphClockChanged) then FOnGraphClockChanged(self);
      EC_COMPLETE                  : if assigned(FOnGraphComplete) then FOnGraphComplete(self, Param1, IBaseFilter(Param2));
      EC_DEVICE_LOST               : if assigned(FOnGraphDeviceLost) then FOnGraphDeviceLost(self,IUnKnown(Param1),(Param2 = 1));
      EC_END_OF_SEGMENT            : if assigned(FOnGraphEndOfSegment) then FOnGraphEndOfSegment(self, PReference_Time(Param1)^, Param2);
      EC_ERROR_STILLPLAYING        : if assigned(FOnGraphErrorStillPlaying) then FOnGraphErrorStillPlaying(self, Param1);
      EC_ERRORABORT                : if assigned(FOnGraphErrorAbort) then FOnGraphErrorAbort(self, Param1);
      EC_FULLSCREEN_LOST           : if assigned(FOnGraphFullscreenLost) then FOnGraphFullscreenLost(self, IBaseFilter(Param2));
      EC_GRAPH_CHANGED             : if assigned(FOnGraphChanged) then FOnGraphChanged(self);
      EC_OLE_EVENT                 : if assigned(FOnGraphOleEvent) then FOnGraphOleEvent(self, TBSTR(Param1), TBSTR(Param2));
      EC_OPENING_FILE              : if assigned(FOnGraphOpeningFile) then FOnGraphOpeningFile(self, (Param1 = 1));
      EC_PALETTE_CHANGED           : if assigned(FOnGraphPaletteChanged) then FOnGraphPaletteChanged(self);
      EC_PAUSED                    : if assigned(FOnGraphPaused) then FOnGraphPaused(self, Param1);
      EC_QUALITY_CHANGE            : if assigned(FOnGraphQualityChange) then FOnGraphQualityChange(self);
      EC_SNDDEV_IN_ERROR           : if assigned(FOnGraphSNDDevInError) then FOnGraphSNDDevInError(self, TSNDDEV_ERR(Param1), Param2);
      EC_SNDDEV_OUT_ERROR          : if assigned(FOnGraphSNDDevOutError) then FOnGraphSNDDevOutError(self, TSNDDEV_ERR(Param1), Param2);
      EC_STEP_COMPLETE             : if assigned(FOnGraphStepComplete) then FOnGraphStepComplete(self);
      EC_STREAM_CONTROL_STARTED    : if assigned(FOnGraphStreamControlStarted) then FOnGraphStreamControlStarted(self, IPin(Param1), Param2);
      EC_STREAM_CONTROL_STOPPED    : if assigned(FOnGraphStreamControlStopped) then FOnGraphStreamControlStopped(self, IPin(Param1), Param2);
      EC_STREAM_ERROR_STILLPLAYING : if assigned(FOnGraphStreamErrorStillPlaying) then FOnGraphStreamErrorStillPlaying(self, Param1, Param2);
      EC_STREAM_ERROR_STOPPED      : if assigned(FOnGraphStreamErrorStopped) then FOnGraphStreamErrorStopped(self, Param1, Param2);
      EC_USERABORT                 : if assigned(FOnGraphUserAbort) then FOnGraphUserAbort(self);
      EC_VIDEO_SIZE_CHANGED        : if assigned(FOnGraphVideoSizeChanged) then FOnGraphVideoSizeChanged(self, TVideoSize(Param1));
      EC_TIMECODE_AVAILABLE        : if assigned(FOnGraphTimeCodeAvailable) then FOnGraphTimeCodeAvailable(self,IBaseFilter(Param1), Param2);
      EC_EXTDEVICE_MODE_CHANGE     : if assigned(FOnGraphEXTDeviceModeChange) then FOnGraphEXTDeviceModeChange(self, Param1, Param2);
    end;
  end;

  function TDSGraph.Connected: boolean;
  begin
    result := (GraphBuilder <> nil);
  end;

  procedure TDSGraph.QueryInterfaces;
  begin
    If Assigned(MediaEventEx) then
      MediaEventEx.SetNotifyWindow(FHandle,WM_GRAPHNOTIFY,ULONG(MediaEventEx));
    if assigned(FVW) then FVW.SetGraph(self);
  end;

  procedure TDSGraph.SetROT(value: boolean);
  begin
    if connected then
    case value of
      true  : AddGraphToROT(GraphBuilder, dwregister);
      false : RemoveGraphFromRot(dwregister);
    end;
    FRotEnabled := value;
  end;

  procedure TDSGraph.ClearGraph;
  var EnumFilters : IEnumFilters;
      BaseFilter  : IBaseFilter;
  Begin
    if assigned(GraphBuilder) then
    begin
      if assigned(MediaControl) then MediaControl.Stop;
      if (GraphBuilder.EnumFilters(EnumFilters)=S_OK) then
      begin
        While (EnumFilters.Next(1,BaseFilter,nil)=S_OK) do
        begin
          GraphBuilder.RemoveFilter(BaseFilter);
          EnumFilters.Reset;
        end;
      end;
    end;
  end;
//******************************************************************************
//
// TDSFilterGraph2 implementation
//
//******************************************************************************

  procedure TDSFilterGraph2.InitServerData;
  const
    CServerData: TServerData = (
      ClassID:   '{E436EBB3-524F-11CE-9F53-0020AF0BA770}'; // CLSID_FilterGraph
      IntfIID:   '{36B73882-C2C8-11CF-8B46-00805F6CEF60}'; // IID_IFilterGraph2
      EventIID:  '';
      LicenseKey: nil;
      Version: 500);
  begin
    ServerData := @CServerData;
  end;

  procedure TDSFilterGraph2.DoEvent(Event, Param1, Param2: longint);
  begin
    if assigned(FTB)then
    case Event of
      EC_COMPLETE       : FTB.ReceiveEndOfStream;
      EC_CLOCK_CHANGED  : FTB.Timer;
    end;
    inherited DoEvent(Event, Param1, Param2);
  end;

  constructor TDSFilterGraph2.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
  end;

  destructor TDSFilterGraph2.Destroy;
  begin
    inherited Destroy;
  end;

  procedure TDSFilterGraph2.Connect;
  var
    punk: IUnknown;
  begin
    if FilterGraph2 = nil then
    begin
      punk := GetServer;
      FilterGraph2 := punk as IFilterGraph2;
      GraphBuilder := punk as IGraphBuilder; // compatibilty
      if RotEnabled then SetRot(true);
    end;
  end;

  procedure TDSFilterGraph2.Disconnect;
  begin
    if Assigned(MediaEventEx) then
      MediaEventEx.SetNotifyFlags(AM_MEDIAEVENT_NONOTIFY);
    if FilterGraph2 <> nil then
    begin
      if RotEnabled then SetRot(false);
      FilterGraph2    := nil;
      GraphBuilder    := nil;
      MediaControl    := nil;
      MediaEventEx    := nil;
      VideoWindow     := nil;
      BasicAudio      := nil;
      BasicVideo2     := nil;
      MediaSeeking    := nil;
      AMGraphStreams  := nil;
      FilterChain     := nil;
      FilterMapper2   := nil;
      GraphConfig     := nil;
      GraphVersion    := nil;
      MediaEventSink  := nil;
      QueueCommand    := nil;
      ResourceManager := nil;
      VideoFrameStep  := nil;
    end;
  end;

  procedure TDSFilterGraph2.QueryInterfaces;
  begin
    if FilterGraph2 <> nil then
    begin
      FilterGraph2.QueryInterface(IID_IMediaControl, MediaControl);
      FilterGraph2.QueryInterface(IID_IMediaEventEx, MediaEventEx);
      FilterGraph2.QueryInterface(IID_IVideoWindow, VideoWindow);
      FilterGraph2.QueryInterface(IID_IBasicAudio, BasicAudio);
      FilterGraph2.QueryInterface(IID_IBasicVideo2, BasicVideo2);
      FilterGraph2.QueryInterface(IID_IMediaSeeking, MediaSeeking);
      FilterGraph2.QueryInterface(IID_IAMGraphStreams, AMGraphStreams);
      FilterGraph2.QueryInterface(IID_IFilterChain, FilterChain);
      FilterGraph2.QueryInterface(IID_IFilterMapper2, FilterMapper2);
      FilterGraph2.QueryInterface(IID_IGraphConfig, GraphConfig);
      FilterGraph2.QueryInterface(IID_IGraphVersion, GraphVersion);
      FilterGraph2.QueryInterface(IID_IMediaEventSink, MediaEventSink);
      FilterGraph2.QueryInterface(IID_IQueueCommand, QueueCommand);
      FilterGraph2.QueryInterface(IID_IResourceManager, ResourceManager);
      FilterGraph2.QueryInterface(IID_IVideoFrameStep, VideoFrameStep);
    end;
    if assigned(FTB) then FTB.SetGraph(self);
    inherited QueryInterfaces;
  end;

  procedure TDSFilterGraph2.ClearGraph;
  begin
    if assigned(GraphBuilder) then
    begin
      if assigned(FTB) then FTB.SetRate(1);
    end;
    inherited ClearGraph;
  end;

//******************************************************************************
//
// TDSDVDGraph implementation
//
//******************************************************************************
  procedure TDSDVDGraph.InitServerData;
  const
    CServerData: TServerData = (
      ClassID:   '{FCC152B7-F372-11D0-8E00-00C04FD7C08B}'; // CLSID_DvdGraphBuilder
      IntfIID:   '{FCC152B6-F372-11d0-8E00-00C04FD7C08B}'; // IID_IDvdGraphBuilder
      EventIID:  '';
      LicenseKey: nil;
      Version: 500);
  begin
    ServerData := @CServerData;
  end;

  procedure TDSDVDGraph.DoEvent(Event, Param1, Param2: longint);
  var 
    lcid    : cardinal;
    achLang : array[0..MAX_PATH] of Char;
    tc      : TDVD_TIMECODE;
    frate   : integer;
    hmsftc  : TDVD_HMSF_TIMECODE;
  begin
    inherited DoEvent(Event, Param1, Param2);
    case Event of
      EC_DVD_ANGLE_CHANGE            : if Assigned(FOnDVDAngleChange) then FOnDVDAngleChange(self,Param1,Param2);
      EC_DVD_AUDIO_STREAM_CHANGE     :
        begin
          if Assigned(FOnDVDAudioStreamChange) then
          begin
            DvdInfo2.GetAudioLanguage(Param1, lcid);
            GetLocaleInfo(lcid, LOCALE_SENGLANGUAGE, achLang, MAX_PATH);
            FOnDVDAudioStreamChange(self, Param1, lcid, string(achLang));
          end;
        end;
      EC_DVD_BUTTON_CHANGE           : if Assigned(FOnDVDButtonChange) then FOnDVDButtonChange(self, Param1, Param2);
      EC_DVD_CHAPTER_AUTOSTOP        : if Assigned(FOnDVDChapterAutoStop) then FOnDVDChapterAutoStop(self);
      EC_DVD_CHAPTER_START           : if Assigned(FOnDVDChapterStart) then FOnDVDChapterStart(self, Param1);
      EC_DVD_CURRENT_TIME            :
        begin
          if Assigned(FOnDVDCurrentTime) then
          begin
            tc := IntToTimeCode(Param1);
            case tc.FrameRateCode of
              1 : frate := 25;
              3 : frate := 30;
            else
              frate := 0;
            end;
            FOnDVDCurrentTime(self,tc.Hours1+tc.Hours10*10,tc.Minutes1+tc.Minutes10*10,tc.Seconds1+tc.Seconds10*10,tc.Frames1+tc.Frames10*10,frate);
          end;
        end;
      EC_DVD_DOMAIN_CHANGE           :
        begin
          case Param1 of
            1 : if Assigned(FOnDVDDomainFirstPlay) then FOnDVDDomainFirstPlay(self);
            2 : if Assigned(FOnDVDDomainVideoManagerMenu) then FOnDVDDomainVideoManagerMenu(self);
            3 : if Assigned(FOnDVDDomainVideoTitleSetMenu) then FOnDVDDomainVideoTitleSetMenu(self);
            4 : if Assigned(FOnDVDDomainTitle) then FOnDVDDomainTitle(self);
            5 : if Assigned(FOnDVDDomainStop) then FOnDVDDomainStop(self);
          end;
        end;
      EC_DVD_ERROR                   :
        begin
          case Param1 of
            1 : if Assigned(FOnDVDErrorUnexpected) then FOnDVDErrorUnexpected(self);
            2 : if Assigned(FOnDVDErrorCopyProtectFail) then FOnDVDErrorCopyProtectFail(self);
            3 : if Assigned(FOnDVDErrorInvalidDVD1_0Disc) then FOnDVDErrorInvalidDVD1_0Disc(self);
            4 : if Assigned(FOnDVDErrorInvalidDiscRegion) then FOnDVDErrorInvalidDiscRegion(self);
            5 : if Assigned(FOnDVDErrorLowParentalLevel) then FOnDVDErrorLowParentalLevel(self);
            6 : if Assigned(FOnDVDErrorMacrovisionFail) then FOnDVDErrorMacrovisionFail(self);
            7 : if Assigned(FOnDVDErrorIncompatibleSystemAndDecoderRegions) then FOnDVDErrorIncompatibleSystemAndDecoderRegions(self);
            8 : if Assigned(FOnDVDErrorIncompatibleDiscAndDecoderRegions) then FOnDVDErrorIncompatibleDiscAndDecoderRegions(self);
          end;
        end;
      EC_DVD_NO_FP_PGC               : if Assigned(FOnDVDNoFP_PGC) then FOnDVDNoFP_PGC(self);
      EC_DVD_STILL_OFF               : if Assigned(FOnDVDStillOff) then FOnDVDStillOff(self);
      EC_DVD_STILL_ON                : if Assigned(FOnDVDStillOn) then FOnDVDStillOn(self,(Param1 = 1), Param2);
      EC_DVD_SUBPICTURE_STREAM_CHANGE:
        begin
          if Assigned(FOnDVDSubpictureStreamChange) then
          begin
            DvdInfo2.GetSubpictureLanguage(Param1,lcid);
            GetLocaleInfo(lcid,LOCALE_SENGLANGUAGE,achLang,MAX_PATH);
            FOnDVDSubpictureStreamChange(self,Param1,lcid,string(achLang));
          end;
        end;
      EC_DVD_TITLE_CHANGE            : if Assigned(FOnDVDTitleChange) then FOnDVDTitleChange(self,Param1);
      EC_DVD_VALID_UOPS_CHANGE       : if Assigned(FOnDVDValidUOPSChange) then FOnDVDValidUOPSChange(self,IntToUOPS(Param1));
      EC_DVD_WARNING                 :
        begin
          case Param1 of
            1 : if Assigned(FOnDVDWarningInvalidDVD1_0Disc)  then FOnDVDWarningInvalidDVD1_0Disc(self);
            2 : if Assigned(FOnDVDWarningFormatNotSupported) then FOnDVDWarningFormatNotSupported(self);
            3 : if Assigned(FOnDVDWarningIllegalNavCommand)  then FOnDVDWarningIllegalNavCommand(self);
            4 : if Assigned(FOnDVDWarningOpen)  then FOnDVDWarningOpen(self);
            5 : if Assigned(FOnDVDWarningSeek)  then FOnDVDWarningSeek(self);
            6 : if Assigned(FOnDVDWarningRead)  then FOnDVDWarningRead(self);
          end;
        end;
      EC_DVD_PLAYBACK_RATE_CHANGE    : if Assigned(FOnDVDPlaybackRateChange) then FOnDVDPlaybackRateChange(self,trunc(Param1/10000));
      EC_DVD_PARENTAL_LEVEL_CHANGE   : if Assigned(FOnDVDParentalLevelChange) then FOnDVDParentalLevelChange(self,Param1);
      EC_DVD_PLAYBACK_STOPPED        : if Assigned(FOnDVDPlaybackStopped) then FOnDVDPlaybackStopped(self);
      EC_DVD_ANGLES_AVAILABLE        : if Assigned(FOnDVDAnglesAvailable) then FOnDVDAnglesAvailable(self,(Param1 = 1));
      EC_DVD_PLAYPERIOD_AUTOSTOP     : if Assigned(FOnDVDPlayPeriodAutoStop) then FOnDVDPlayPeriodAutoStop(self);
      EC_DVD_BUTTON_AUTO_ACTIVATED   : if Assigned(FOnDVDButtonAutoActivated) then FOnDVDButtonAutoActivated(self,Param1);
      EC_DVD_CMD_START               : if Assigned(FOnDVDCMDStart) then FOnDVDCMDStart(self,Param1);
      EC_DVD_CMD_END                 : if Assigned(FOnDVDCMDEnd) then FOnDVDCMDEnd(self,Param1);
      EC_DVD_DISC_EJECTED            : if Assigned(FOnDVDDiscEjected) then FOnDVDDiscEjected(self);
      EC_DVD_DISC_INSERTED           : if Assigned(FOnDVDDiscInserted) then FOnDVDDiscInserted(self);
      EC_DVD_CURRENT_HMSF_TIME       :
        begin
          if assigned(FOnDVDCurrentHMSFTime) then
            begin
              hmsftc := TDVD_HMSF_TIMECODE(param1);
              tc := IntToTimeCode(Param2);
              FOnDVDCurrentHMSFTime(self,hmsftc,tc);
            end;
        end;
      EC_DVD_KARAOKE_MODE            : if assigned(FOnDVDKaraokeMode) then FOnDVDKaraokeMode(self,BOOL(Param1));
    end;
  end;

  constructor TDSDVDGraph.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
  end;

  destructor TDSDVDGraph.Destroy;
  begin
    inherited Destroy;
  end;

  procedure TDSDVDGraph.Connect;
  var
    punk: IUnknown;
  begin
    if DvdGraphBuilder = nil then
    begin
      punk := GetServer;
      DvdGraphBuilder := punk as IDvdGraphBuilder;
      DvdGraphBuilder.GetFiltergraph(GraphBuilder);
      if RotEnabled then SetRot(true);
    end;
  end;

  procedure TDSDVDGraph.Disconnect;
  begin
    if DvdGraphBuilder <> nil then
    begin
      DvdGraphBuilder := nil;
      DvdControl2     := nil;
      DvdInfo2        := nil;
      AMLine21Decoder := nil;
    end;
    if Assigned(MediaEventEx) then
      MediaEventEx.SetNotifyFlags(AM_MEDIAEVENT_NONOTIFY);
    if GraphBuilder <> nil then
    begin
      if RotEnabled then SetRot(false);
      GraphBuilder    := nil;
      MediaControl    := nil;
      MediaEventEx    := nil;
      VideoWindow     := nil;
      BasicAudio      := nil;
      BasicVideo2     := nil;
      MediaSeeking    := nil;
      AMGraphStreams  := nil;
      FilterChain     := nil;
      FilterMapper2   := nil;
      GraphConfig     := nil;
      GraphVersion    := nil;
      MediaEventSink  := nil;
      QueueCommand    := nil;
      ResourceManager := nil;
      VideoFrameStep  := nil;
    end;
  end;

  procedure TDSDVDGraph.QueryInterfaces;
  begin
    if DvdGraphBuilder <> nil then
    begin
      DvdGraphBuilder.GetDvdInterface(IID_IDvdControl2, DvdControl2);
      DvdGraphBuilder.GetDvdInterface(IID_IDvdInfo2, DvdInfo2);
      DvdGraphBuilder.GetDvdInterface(IID_IAMLine21Decoder, AMLine21Decoder);
    end;
    if GraphBuilder <> nil then
    begin
      GraphBuilder.QueryInterface(IID_IMediaControl, MediaControl);
      GraphBuilder.QueryInterface(IID_IMediaEventEx, MediaEventEx);
      GraphBuilder.QueryInterface(IID_IVideoWindow, VideoWindow);
      GraphBuilder.QueryInterface(IID_IBasicAudio, BasicAudio);
      GraphBuilder.QueryInterface(IID_IBasicVideo2, BasicVideo2);
      GraphBuilder.QueryInterface(IID_IMediaSeeking, MediaSeeking);
      GraphBuilder.QueryInterface(IID_IAMGraphStreams, AMGraphStreams);
      GraphBuilder.QueryInterface(IID_IFilterChain, FilterChain);
      GraphBuilder.QueryInterface(IID_IFilterMapper2, FilterMapper2);
      GraphBuilder.QueryInterface(IID_IGraphConfig, GraphConfig);
      GraphBuilder.QueryInterface(IID_IGraphVersion, GraphVersion);
      GraphBuilder.QueryInterface(IID_IMediaEventSink, MediaEventSink);
      GraphBuilder.QueryInterface(IID_IQueueCommand, QueueCommand);
      GraphBuilder.QueryInterface(IID_IResourceManager, ResourceManager);
      GraphBuilder.QueryInterface(IID_IVideoFrameStep, VideoFrameStep);
    end;
    inherited QueryInterfaces;
  end;

  procedure TDSDVDGraph.SaveBookmark(BookMarkFile: string);
  const
      IID_IPersistStream   : TGUID = '{00000109-0000-0000-C000-000000000046}';
  var hr: HRESULT;
      Bookmark: IDvdState;
      pStorage: IStorage;
      pStream : IStream;
      PersistStream : IPersistStream;
  begin
    if assigned(DVDInfo2) then
    begin
      DVDInfo2.GetState(Bookmark);
      StgCreateDocfile(StringToOleStr(BookMarkFile), STGM_CREATE or STGM_WRITE or STGM_SHARE_EXCLUSIVE, 0, pStorage);
      pStorage.CreateStream('BookMark', STGM_CREATE or STGM_WRITE or STGM_SHARE_EXCLUSIVE, 0, 0, pStream);
      hr := Bookmark.QueryInterface(IID_IPersistStream,PersistStream);
      if (SUCCEEDED(hr)) then
        begin
          OleSaveToStream(PersistStream,pStream);
          PersistStream := nil;
       end
       else
       begin
         PersistStream := nil;
         exit;
       end;
    end;
  end;

  procedure TDSDVDGraph.RestoreBookmark(BookMarkFile: string);
  var pStorage : IStorage;
      pStream  : IStream;
      pBookmark: IDvdState;
      hr       : HRESULT;
      obj      : IDVDCmd;
  begin
    if assigned(DVDControl2) then
    begin
      StgOpenStorage(StringToOleStr(BookMarkFile), nil, STGM_READ or STGM_SHARE_EXCLUSIVE, nil , 0, pStorage);
      pStorage.OpenStream('BookMark', nil, STGM_READ or STGM_SHARE_EXCLUSIVE, 0, pStream);
      OleLoadFromStream(pStream, IID_IDvdState, pBookmark);
      hr := DVDControl2.SetState(pBookmark, DVD_CMD_FLAG_None, obj);
      if not (failed(hr)) then
        begin
          obj.WaitForEnd;
          obj := nil;
        end;
    end;
  end;

//******************************************************************************
//
// TDSCaptureGraph implementation
//
//******************************************************************************

  procedure TDSCaptureGraph.InitServerData;
  begin
    inherited InitServerData;
  end;

  constructor TDSCaptureGraph.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
  end;

  destructor TDSCaptureGraph.Destroy;
  begin
    inherited Destroy;
  end;

  procedure TDSCaptureGraph.Connect;
  begin
    inherited Connect;
    if CaptureGraphBuilder2 = nil then
    begin
      CoCreateInstance(CLSID_CaptureGraphBuilder2, nil, CLSCTX_INPROC, IID_ICaptureGraphBuilder2, CaptureGraphBuilder2);
      CaptureGraphBuilder2.SetFiltergraph(FilterGraph2);
    end;
  end;

  procedure TDSCaptureGraph.Disconnect;
  begin
    if CaptureGraphBuilder2 <> nil then
    begin
      CaptureGraphBuilder2 := nil;
    end;
    inherited Disconnect;
  end;

  procedure TDSCaptureGraph.QueryInterfaces;
  begin
    inherited QueryInterfaces;
  end;

//******************************************************************************
//
// TDSSysDevEnum implementation
//
//******************************************************************************
procedure TDSSysDevEnum.GetCat(catlist: TList; CatGUID: TGUID);
var
  SysDevEnum  : ICreateDevEnum;
  EnumCat     : IEnumMoniker;
  Moniker     : IMoniker;
  Fetched     : ULONG;
  PropBag     : IPropertyBag;
  Name        : olevariant;
  hr          : HRESULT;
begin
  SysDevEnum := nil;
  EnumCat    := nil;
  catList.Clear;
  CocreateInstance(CLSID_SystemDeviceEnum, nil, CLSCTX_INPROC, IID_ICreateDevEnum, SysDevEnum);
  hr := SysDevEnum.CreateClassEnumerator(CatGUID, EnumCat, 0);
  if (hr = S_OK) then
  begin
    while(EnumCat.Next(1, Moniker, @Fetched) = S_OK) do
      begin
        Moniker.BindToStorage(nil, nil, IID_IPropertyBag, PropBag);
        new(ACategory);
        PropBag.Read('FriendlyName', Name, nil);
        ACategory^.FriendlyName := Name;
        if (PropBag.Read('CLSID',Name,nil) = S_OK) then
          ACategory^.CLSID := StringToGUID(Name)
        else
          ACategory^.CLSID := GUID_NULL;
        catlist.Add(ACategory);
        PropBag := nil;
        Moniker := nil;
      end;
  end;
  EnumCat :=nil;
  SysDevEnum :=nil;
end;

Constructor TDSSysDevEnum.Create;
begin
  FCategories := TList.Create;
  FFilters    := TList.Create;
  getcat(FCategories,CLSID_ActiveMovieCategories);
end;

destructor TDSSysDevEnum.Destroy;
begin
  inherited Destroy;
  FCategories.Free;
  FFilters.Free;
end;

function TDSSysDevEnum.GetCategory(item: integer): TDSFilCatNode;
var PCategory: PDSFilCatNode;
begin
  PCategory := FCategories.Items[item];
  result := PCategory^;
end;

function TDSSysDevEnum.GetFilter(item: integer): TDSFilCatNode;
var PCategory: PDSFilCatNode;
begin
  PCategory := FFilters.Items[item];
  result := PCategory^;
end;

function TDSSysDevEnum.GetCountCategories: integer;
begin
  result := FCategories.Count;
end;

function TDSSysDevEnum.GetCountFilters: integer;
begin
  result := FFilters.Count;
end;

procedure TDSSysDevEnum.SelectGUIDCategory(GUID: TGUID);
begin
  FGUID := GUID;
  getcat(FFilters,FGUID);
end;

procedure TDSSysDevEnum.SelectIndexCategory(index: integer);
begin
  SelectGUIDCategory(Categories[index].CLSID);
end;

function TDSSysDevEnum.GetBaseFilterByIndex(index: integer): IBaseFilter;
var
  SysDevEnum  : ICreateDevEnum;
  EnumCat     : IEnumMoniker;
  Moniker     : IMoniker;
  Fetched     : ULONG;
begin
  result := nil;
  if ((index < CountFilters) and (index >= 0)) then
    begin
      SysDevEnum := nil;
      EnumCat    := nil;
      Moniker    := nil;
      CocreateInstance(CLSID_SystemDeviceEnum, nil, CLSCTX_INPROC, IID_ICreateDevEnum, SysDevEnum);
      SysDevEnum.CreateClassEnumerator(FGUID, EnumCat, 0);
      EnumCat.Next(index+1, Moniker, @Fetched);
      Moniker.BindToObject(nil, nil, IID_IBaseFilter, result);
      SysDevEnum := nil;
      EnumCat    := nil;
      Moniker    := nil;
    end
end;

//******************************************************************************
//
// TDSTrackBar implementation
//
//******************************************************************************
  constructor TDSTrackBar.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    FWindowHandle := AllocateHWnd(WndProc2);
    FInterval := 0;
    ThumbLength := 15;
    Height := 25;
    if assigned(FGRAPH) then SetGraph(FGRAPH);
    Settimerenabled(false);
  end;

  destructor TDSTrackBar.Destroy;
  begin
    Settimerenabled(False);
    DeallocateHWnd(FWindowHandle);
    inherited Destroy;
  end;

  procedure TDSTrackBar.WndProc2(var Msg: TMessage);
  begin
    with Msg do
      if Msg = WM_TIMER then
        try
          Timer;
        except
          Application.HandleException(Self);
        end
      else
        Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
  end;

  procedure TDSTrackBar.UpdateTimer;
  var y: int64;
  begin
    if SeekingAvailable then
    begin
      KillTimer(FWindowHandle, 1);
      FGraph.MediaSeeking.GetDuration(y);
      FInterval := round((y*0.0001)/(max*rate));
      if (FInterval <> 0) and FTimerEnable then
        if SetTimer(FWindowHandle, 1, FInterval, nil) = 0 then
          raise EOutOfResources.Create(SNoTimers);
    end;
  end;

  procedure TDSTrackBar.SetTimerEnabled(Value: Boolean);
  begin
    if (Value <> FTimerEnable) then
    begin
      FTimerEnable := Value;
      UpdateTimer;
    end;
  end;

  procedure TDSTrackBar.Timer;
  var x,y: int64;
  begin
    if SeekingAvailable then
    begin
      FGraph.MediaSeeking.GetCurrentPosition(x);
      FGraph.MediaSeeking.GetDuration(y);
      SelStart := 0;
      SelEnd := round((x*max)/(y));
    end;
  end;

  procedure TDSTrackBar.Changed;
  var SStart, SStop, y: int64;
  begin
    inherited Changed;
    if SeekingAvailable then
    begin
      FGraph.MediaSeeking.GetDuration(y);
      SStart := round((Position*y)/max);
      FGraph.MediaSeeking.SetPositions(SStart,AM_SEEKING_AbsolutePositioning,SStop,AM_SEEKING_NoPositioning);
      Timer;
    end;
  end;

  procedure TDSTrackBar.SetGraph(grf: TDSFilterGraph2);
  var duration, SStart, SStop: int64;
  begin
    if assigned(FGraph) then FGraph.FTB := nil;
    FGraph := grf;
    if assigned(FGraph) then
    begin
      FGraph.FTB := self;
      if SeekingAvailable then
      begin
        if ([CanSeekAbsolute, CanGetDuration] <= Capabilities) then
        begin
          SelStart := 0;
          Min := 0;
          FGraph.MediaSeeking.GetDuration(duration);
          SStart :=0; SStop := 0;
          FGraph.MediaSeeking.SetPositions(SStart,AM_SEEKING_AbsolutePositioning,SStop,AM_SEEKING_NoPositioning);
          Enabled := True;
          position := 0;
          SetTimerEnabled(true);
          UpdateTimer;
        end
        else
        begin
          SetTimerEnabled(false);
          SelEnd := 0;
          Enabled := false;
        end;
      end;
    end;
  end;

  function TDSTrackBar.SeekingAvailable: boolean;
  begin
    result := false;
    if assigned(FGraph) then
      if assigned(FGraph.MediaSeeking) then result := true;
  end;

  function  TDSTrackBar.GetCapabilities: TDSAMSeekingKind;
  begin
    result := [];
    if SeekingAvailable then FGraph.MediaSeeking.GetCapabilities(PULONG(@result)^);
  end;

  function  TDSTrackBar.GetRate: double;
  begin
    result := 0;
    if SeekingAvailable then FGraph.MediaSeeking.GetRate(result);
  end;

  procedure TDSTrackBar.SetRate(rate: Double);
  begin
    if (SeekingAvailable and (rate <> 0)) then
    begin
      FGraph.MediaSeeking.SetRate(rate);
      UpdateTimer;
    end;

  end;

  procedure TDSTrackBar.ReceiveEndOfStream;
  begin
    FGraph.MediaControl.Stop;
    Position := 0;
    SelEnd := 0;
  end;

//******************************************************************************

// REGISTER
  procedure Register;
  begin
    RegisterComponents('Direct Show', [TDSFilterGraph2, TDSDVDGraph, TDSCaptureGraph,
      TDSVideoWindow, TDSTrackBar]);
  end;

end.
